Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 73718)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIToolPaneGlobal.cpp	(revision 73721)
@@ -111,5 +111,5 @@
             {
                 /* Create Virtual Media Manager: */
-                m_pPaneMedia = new UIMediumManagerWidget(EmbedTo_Stack, m_pActionPool);
+                m_pPaneMedia = new UIMediumManagerWidget(EmbedTo_Stack, m_pActionPool, false /* show toolbar */);
                 AssertPtrReturnVoid(m_pPaneMedia);
                 {
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 73718)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 73721)
@@ -114,4 +114,5 @@
     , m_pSnapshotMenuAction(0)
     , m_pLogViewerMenuAction(0)
+    , m_pVirtualMediaManagerMenuAction(0)
     , m_pManagerVirtualMedia(0)
     , m_pManagerHostNetwork(0)
@@ -1237,4 +1238,8 @@
     m_pLogViewerMenuAction = menuBar()->addMenu(actionPool()->action(UIActionIndex_M_LogViewer)->menu());
 
+    /* Prepare 'Medium' menu: */
+    prepareMenuMedium(actionPool()->action(UIActionIndexST_M_Medium)->menu());
+    m_pVirtualMediaManagerMenuAction = menuBar()->addMenu(actionPool()->action(UIActionIndexST_M_Medium)->menu());
+
 #ifdef VBOX_WS_MAC
     /* Prepare 'Window' menu: */
@@ -1655,9 +1660,28 @@
     /* Remember action list: */
     m_logViewerActions << actionPool()->action(UIActionIndex_M_LogViewer_T_Find)
-                 << actionPool()->action(UIActionIndex_M_LogViewer_T_Filter)
-                 << actionPool()->action(UIActionIndex_M_LogViewer_T_Bookmark)
-                 << actionPool()->action(UIActionIndex_M_LogViewer_T_Settings)
-                 << actionPool()->action(UIActionIndex_M_LogViewer_S_Refresh)
-                 << actionPool()->action(UIActionIndex_M_LogViewer_S_Save);
+                       << actionPool()->action(UIActionIndex_M_LogViewer_T_Filter)
+                       << actionPool()->action(UIActionIndex_M_LogViewer_T_Bookmark)
+                       << actionPool()->action(UIActionIndex_M_LogViewer_T_Settings)
+                       << actionPool()->action(UIActionIndex_M_LogViewer_S_Refresh)
+                       << actionPool()->action(UIActionIndex_M_LogViewer_S_Save);
+}
+
+void UIVirtualBoxManager::prepareMenuMedium(QMenu *pMenu)
+{
+    /* We are doing it inside the UIActionPoolSelector. */
+    Q_UNUSED(pMenu);
+
+    /* Do not touch if filled already: */
+    if (!m_virtualMediaManagerActions.isEmpty())
+        return;
+
+    /* Remember action list: */
+    m_virtualMediaManagerActions << actionPool()->action(UIActionIndexST_M_Medium_S_Add)
+                                 << actionPool()->action(UIActionIndexST_M_Medium_S_Copy)
+                                 << actionPool()->action(UIActionIndexST_M_Medium_S_Move)
+                                 << actionPool()->action(UIActionIndexST_M_Medium_S_Remove)
+                                 << actionPool()->action(UIActionIndexST_M_Medium_S_Release)
+                                 << actionPool()->action(UIActionIndexST_M_Medium_T_Details)
+                                 << actionPool()->action(UIActionIndexST_M_Medium_S_Refresh);
 }
 
@@ -1946,4 +1970,5 @@
 {
     /* Determine whether Machine or Group menu should be shown at all: */
+    const bool fGlobalMenuShown = m_pWidget->isGlobalItemSelected();
     const bool fMachineOrGroupMenuShown = m_pWidget->isMachineItemSelected() || m_pWidget->isGroupItemSelected();
     const bool fMachineMenuShown = !isSingleGroupSelected();
@@ -1958,4 +1983,8 @@
     const bool fLogViewerMenuShown = fMachineOrGroupMenuShown && m_pWidget->currentMachineTool() == ToolTypeMachine_LogViewer;
     m_pLogViewerMenuAction->setVisible(fLogViewerMenuShown);
+
+    /* Determine whether VirtualMediaManager actions should be visible: */
+    const bool fMediumMenuShown = fGlobalMenuShown && m_pWidget->currentGlobalTool() == ToolTypeGlobal_VirtualMedia;
+    m_pVirtualMediaManagerMenuAction->setVisible(fMediumMenuShown);
 
     /* Hide action shortcuts: */
@@ -1976,4 +2005,6 @@
     foreach (UIAction *pAction, m_logViewerActions)
         pAction->setVisible(fLogViewerMenuShown);
+    foreach (UIAction *pAction, m_virtualMediaManagerActions)
+        pAction->setVisible(fMediumMenuShown);
 
     /* Show action shortcuts: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.h	(revision 73718)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.h	(revision 73721)
@@ -252,4 +252,6 @@
         /** Prepares @a pMenu Log Viewer. */
         void prepareMenuLogViewer(QMenu *pMenu);
+        /** Prepares @a pMenu Medium. */
+        void prepareMenuMedium(QMenu *pMenu);
         /** Prepares status-bar. */
         void prepareStatusBar();
@@ -359,6 +361,11 @@
     /** Holds the list of Log Viewer menu actions. */
     QList<UIAction*>  m_logViewerActions;
-    /** Holds the Log menu parent action. */
+    /** Holds the Log Viewer menu parent action. */
     QAction          *m_pLogViewerMenuAction;
+
+    /** Holds the list of Virtual Media Manager menu actions. */
+    QList<UIAction*>  m_virtualMediaManagerActions;
+    /** Holds the Virtual Media Manager menu parent action. */
+    QAction          *m_pVirtualMediaManagerMenuAction;
 
     /** Holds the Virtual Media Manager window instance. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 73718)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 73721)
@@ -422,4 +422,13 @@
         m_pToolBar->addAction(actionPool()->action(UIActionIndex_M_LogViewer_S_Refresh));
 
+        /* Add 'Medium' actions block: */
+        m_pToolBar->addAction(actionPool()->action(UIActionIndexST_M_Medium_S_Add));
+        m_pToolBar->addAction(actionPool()->action(UIActionIndexST_M_Medium_S_Copy));
+        m_pToolBar->addAction(actionPool()->action(UIActionIndexST_M_Medium_S_Move));
+        m_pToolBar->addAction(actionPool()->action(UIActionIndexST_M_Medium_S_Remove));
+        m_pToolBar->addAction(actionPool()->action(UIActionIndexST_M_Medium_S_Release));
+        m_pToolBar->addAction(actionPool()->action(UIActionIndexST_M_Medium_T_Details));
+        m_pToolBar->addAction(actionPool()->action(UIActionIndexST_M_Medium_S_Refresh));
+
 #ifdef VBOX_WS_MAC
         // WORKAROUND:
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 73718)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 73721)
@@ -149,8 +149,10 @@
 *********************************************************************************************************************************/
 
-UIMediumManagerWidget::UIMediumManagerWidget(EmbedTo enmEmbedding, UIActionPool *pActionPool, QWidget *pParent /* = 0 */)
+UIMediumManagerWidget::UIMediumManagerWidget(EmbedTo enmEmbedding, UIActionPool *pActionPool,
+                                             bool fShowToolbar /* = true */, QWidget *pParent /* = 0 */)
     : QIWithRetranslateUI<QWidget>(pParent)
     , m_enmEmbedding(enmEmbedding)
     , m_pActionPool(pActionPool)
+    , m_fShowToolbar(fShowToolbar)
     , m_fPreventChangeCurrentItem(false)
     , m_pTabWidget(0)
@@ -769,5 +771,6 @@
 
         /* Prepare toolbar: */
-        prepareToolBar();
+        if (m_fShowToolbar)
+            prepareToolBar();
         /* Prepare tab-widget: */
         prepareTabWidget();
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h	(revision 73718)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h	(revision 73721)
@@ -105,6 +105,9 @@
 public:
 
-    /** Constructs Virtual Media Manager widget. */
-    UIMediumManagerWidget(EmbedTo enmEmbedding, UIActionPool *pActionPool, QWidget *pParent = 0);
+    /** Constructs Virtual Media Manager widget.
+      * @param  enmEmbedding  Brings the type of widget embedding.
+      * @param  pActionPool   Brings the action-pool reference.
+      * @param  fShowToolbar  Brings whether we should create/show toolbar. */
+    UIMediumManagerWidget(EmbedTo enmEmbedding, UIActionPool *pActionPool, bool fShowToolbar = true, QWidget *pParent = 0);
 
     /** Returns the menu. */
@@ -298,7 +301,8 @@
         /** Holds the widget embedding type. */
         const EmbedTo m_enmEmbedding;
-
         /** Holds the action-pool reference. */
         UIActionPool *m_pActionPool;
+        /** Holds whether we should create/show toolbar. */
+        const bool    m_fShowToolbar;
 
         /** Holds whether Virtual Media Manager should preserve current item change. */