Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolSelector.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolSelector.cpp	(revision 73733)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolSelector.cpp	(revision 73734)
@@ -1835,5 +1835,5 @@
     {
         setName(QApplication::translate("UIActionPool", "&Add..."));
-        setStatusTip(QApplication::translate("UIActionPool", "Add a Disk Image File"));
+        setStatusTip(QApplication::translate("UIActionPool", "Add a disk image file"));
         setToolTip(tr("Add a Disk Image File (%1)").arg(shortcut().toString()));
     }
@@ -2239,4 +2239,6 @@
     /* 'Remove' action: */
     fSeparator = addAction(pMenu, action(UIActionIndexST_M_Medium_S_Remove)) || fSeparator;
+    /* 'Release' action: */
+    fSeparator = addAction(pMenu, action(UIActionIndexST_M_Medium_S_Release)) || fSeparator;
 
     /* Separator? */
@@ -2247,6 +2249,4 @@
     }
 
-    /* 'Release' action: */
-    fSeparator = addAction(pMenu, action(UIActionIndexST_M_Medium_S_Release)) || fSeparator;
     /* 'Properties' action: */
     fSeparator = addAction(pMenu, action(UIActionIndexST_M_Medium_T_Details)) || fSeparator;
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 73733)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.cpp	(revision 73734)
@@ -166,5 +166,4 @@
     , m_pDetailsWidget(0)
     , m_pToolBar(0)
-    , m_pContextMenu(0)
     , m_pProgressBar(0)
 {
@@ -189,5 +188,5 @@
 void UIMediumManagerWidget::retranslateUi()
 {
-    /* Translate toolbar: */
+    /* Adjust toolbar: */
 #ifdef VBOX_WS_MAC
     // WORKAROUND:
@@ -617,5 +616,5 @@
 }
 
-void UIMediumManagerWidget::sltHandleContextMenuCall(const QPoint &position)
+void UIMediumManagerWidget::sltHandleContextMenuRequest(const QPoint &position)
 {
     /* Get current tree-widget: */
@@ -623,15 +622,28 @@
     AssertPtrReturnVoid(pTreeWidget);
 
-    /* Make sure underlaying item was found: */
+    /* If underlaying item was found => make sure that item is current one: */
     QTreeWidgetItem *pItem = pTreeWidget->itemAt(position);
-    if (!pItem)
-        return;
-
-    /* Make sure that item is current one: */
-    setCurrentItem(pTreeWidget, pItem);
-
-    /* Show item context menu: */
-    if (m_pContextMenu)
-        m_pContextMenu->exec(pTreeWidget->viewport()->mapToGlobal(position));
+    if (pItem)
+        setCurrentItem(pTreeWidget, pItem);
+
+    /* Compose temporary context-menu: */
+    QMenu menu;
+    if (pTreeWidget->itemAt(position))
+    {
+        menu.addAction(m_pActionPool->action(UIActionIndexST_M_Medium_S_Copy));
+        menu.addAction(m_pActionPool->action(UIActionIndexST_M_Medium_S_Move));
+        menu.addAction(m_pActionPool->action(UIActionIndexST_M_Medium_S_Remove));
+        menu.addAction(m_pActionPool->action(UIActionIndexST_M_Medium_S_Release));
+        menu.addSeparator();
+        menu.addAction(m_pActionPool->action(UIActionIndexST_M_Medium_T_Details));
+    }
+    else
+    {
+        menu.addAction(m_pActionPool->action(UIActionIndexST_M_Medium_S_Add));
+        menu.addSeparator();
+        menu.addAction(m_pActionPool->action(UIActionIndexST_M_Medium_S_Refresh));
+    }
+    /* And show it: */
+    menu.exec(pTreeWidget->viewport()->mapToGlobal(position));
 }
 
@@ -734,24 +746,4 @@
     /* Update action icons: */
     updateActionIcons();
-
-    /* Prepare context-menu: */
-    prepareContextMenu();
-}
-
-void UIMediumManagerWidget::prepareContextMenu()
-{
-    /* Create context-menu: */
-    m_pContextMenu = new QMenu(this);
-    AssertPtrReturnVoid(m_pContextMenu);
-    {
-        /* Configure contex-menu: */
-        m_pContextMenu->addAction(m_pActionPool->action(UIActionIndexST_M_Medium_S_Add));
-        m_pContextMenu->addAction(m_pActionPool->action(UIActionIndexST_M_Medium_S_Copy));
-        m_pContextMenu->addAction(m_pActionPool->action(UIActionIndexST_M_Medium_S_Move));
-        m_pContextMenu->addAction(m_pActionPool->action(UIActionIndexST_M_Medium_S_Remove));
-        m_pContextMenu->addSeparator();
-        m_pContextMenu->addAction(m_pActionPool->action(UIActionIndexST_M_Medium_S_Release));
-        m_pContextMenu->addAction(m_pActionPool->action(UIActionIndexST_M_Medium_T_Details));
-    }
 }
 
@@ -795,6 +787,6 @@
         m_pToolBar->addAction(m_pActionPool->action(UIActionIndexST_M_Medium_S_Move));
         m_pToolBar->addAction(m_pActionPool->action(UIActionIndexST_M_Medium_S_Remove));
+        m_pToolBar->addAction(m_pActionPool->action(UIActionIndexST_M_Medium_S_Release));
         m_pToolBar->addSeparator();
-        m_pToolBar->addAction(m_pActionPool->action(UIActionIndexST_M_Medium_S_Release));
         m_pToolBar->addAction(m_pActionPool->action(UIActionIndexST_M_Medium_T_Details));
         m_pToolBar->addSeparator();
@@ -890,5 +882,5 @@
                 m_pActionPool->action(UIActionIndexST_M_Medium_T_Details), &QAction::setChecked);
         connect(pTreeWidget, &QITreeWidget::customContextMenuRequested,
-                this, &UIMediumManagerWidget::sltHandleContextMenuCall);
+                this, &UIMediumManagerWidget::sltHandleContextMenuRequest);
         connect(pTreeWidget, &QITreeWidget::resized,
                 this, &UIMediumManagerWidget::sltPerformTablesAdjustment, Qt::QueuedConnection);
Index: trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h	(revision 73733)
+++ trunk/src/VBox/Frontends/VirtualBox/src/medium/UIMediumManager.h	(revision 73734)
@@ -188,5 +188,5 @@
         void sltHandleCurrentItemChanged();
         /** Handles item context-menu-call case. */
-        void sltHandleContextMenuCall(const QPoint &position);
+        void sltHandleContextMenuRequest(const QPoint &position);
     /** @} */
 
@@ -209,6 +209,4 @@
         /** Prepares actions. */
         void prepareActions();
-        /** Prepares context-menu. */
-        void prepareContextMenu();
         /** Prepares widgets. */
         void prepareWidgets();
@@ -348,6 +346,4 @@
         /** Holds the toolbar widget instance. */
         UIToolBar *m_pToolBar;
-        /** Holds the context-menu object instance. */
-        QMenu     *m_pContextMenu;
     /** @} */
 