Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp	(revision 73790)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.cpp	(revision 73791)
@@ -106,7 +106,8 @@
 *********************************************************************************************************************************/
 
-UIAction::UIAction(UIActionPool *pParent, UIActionType enmType)
+UIAction::UIAction(UIActionPool *pParent, UIActionType enmType, bool fMachineMenuAction /* = false */)
     : QAction(pParent)
     , m_enmType(enmType)
+    , m_fMachineMenuAction(fMachineMenuAction)
     , m_pActionPool(pParent)
     , m_enmActionPoolType(pParent->type())
@@ -211,11 +212,18 @@
         /* The same as menu name for Selector UI: */
         case UIActionPoolType_Selector:
+        {
             setText(nameInMenu());
             break;
+        }
         /* With shortcut appended for Runtime UI: */
         case UIActionPoolType_Runtime:
-            setText(vboxGlobal().insertKeyToActionText(nameInMenu(),
-                                                       gShortcutPool->shortcut(actionPool(), this).toString()));
+        {
+            if (machineMenuAction())
+                setText(vboxGlobal().insertKeyToActionText(nameInMenu(),
+                                                           gShortcutPool->shortcut(actionPool(), this).toString()));
+            else
+                setText(nameInMenu());
             break;
+        }
     }
 }
@@ -271,12 +279,14 @@
 *********************************************************************************************************************************/
 
-UIActionSimple::UIActionSimple(UIActionPool *pParent)
-    : UIAction(pParent, UIActionType_Simple)
-{
-}
-
 UIActionSimple::UIActionSimple(UIActionPool *pParent,
-                               const QString &strIcon, const QString &strIconDisabled)
-    : UIAction(pParent, UIActionType_Simple)
+                               bool fMachineMenuAction /* = false */)
+    : UIAction(pParent, UIActionType_Simple, fMachineMenuAction)
+{
+}
+
+UIActionSimple::UIActionSimple(UIActionPool *pParent,
+                               const QString &strIcon, const QString &strIconDisabled,
+                               bool fMachineMenuAction /* = false */)
+    : UIAction(pParent, UIActionType_Simple, fMachineMenuAction)
 {
     setIcon(UIIconPool::iconSet(strIcon, strIconDisabled));
@@ -285,6 +295,7 @@
 UIActionSimple::UIActionSimple(UIActionPool *pParent,
                                const QString &strIconNormal, const QString &strIconSmall,
-                               const QString &strIconNormalDisabled, const QString &strIconSmallDisabled)
-    : UIAction(pParent, UIActionType_Simple)
+                               const QString &strIconNormalDisabled, const QString &strIconSmallDisabled,
+                               bool fMachineMenuAction /* = false */)
+    : UIAction(pParent, UIActionType_Simple, fMachineMenuAction)
 {
     setIcon(UIIconPool::iconSetFull(strIconNormal, strIconSmall, strIconNormalDisabled, strIconSmallDisabled));
@@ -292,6 +303,7 @@
 
 UIActionSimple::UIActionSimple(UIActionPool *pParent,
-                               const QIcon &icon)
-    : UIAction(pParent, UIActionType_Simple)
+                               const QIcon &icon,
+                               bool fMachineMenuAction /* = false */)
+    : UIAction(pParent, UIActionType_Simple, fMachineMenuAction)
 {
     setIcon(icon);
@@ -303,12 +315,14 @@
 *********************************************************************************************************************************/
 
-UIActionToggle::UIActionToggle(UIActionPool *pParent)
-    : UIAction(pParent, UIActionType_Toggle)
-{
-}
-
 UIActionToggle::UIActionToggle(UIActionPool *pParent,
-                               const QString &strIcon, const QString &strIconDisabled)
-    : UIAction(pParent, UIActionType_Toggle)
+                               bool fMachineMenuAction /* = false */)
+    : UIAction(pParent, UIActionType_Toggle, fMachineMenuAction)
+{
+}
+
+UIActionToggle::UIActionToggle(UIActionPool *pParent,
+                               const QString &strIcon, const QString &strIconDisabled,
+                               bool fMachineMenuAction /* = false */)
+    : UIAction(pParent, UIActionType_Toggle, fMachineMenuAction)
 {
     setIcon(UIIconPool::iconSet(strIcon, strIconDisabled));
@@ -318,6 +332,7 @@
 UIActionToggle::UIActionToggle(UIActionPool *pParent,
                                const QString &strIconOn, const QString &strIconOff,
-                               const QString &strIconOnDisabled, const QString &strIconOffDisabled)
-    : UIAction(pParent, UIActionType_Toggle)
+                               const QString &strIconOnDisabled, const QString &strIconOffDisabled,
+                               bool fMachineMenuAction /* = false */)
+    : UIAction(pParent, UIActionType_Toggle, fMachineMenuAction)
 {
     setIcon(UIIconPool::iconSetOnOff(strIconOn, strIconOff, strIconOnDisabled, strIconOffDisabled));
@@ -326,6 +341,7 @@
 
 UIActionToggle::UIActionToggle(UIActionPool *pParent,
-                               const QIcon &icon)
-    : UIAction(pParent, UIActionType_Toggle)
+                               const QIcon &icon,
+                               bool fMachineMenuAction /* = false */)
+    : UIAction(pParent, UIActionType_Toggle, fMachineMenuAction)
 {
     if (!icon.isNull())
@@ -482,5 +498,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimplePerformClose(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/exit_16px.png", ":/exit_16px.png")
+        : UIActionSimple(pParent, ":/exit_16px.png", ":/exit_16px.png", true)
     {
         setMenuRole(QAction::QuitRole);
@@ -664,5 +680,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleContents(UIActionPool *pParent)
-        : UIActionSimple(pParent, UIIconPool::defaultIcon(UIIconPool::UIDefaultIconType_DialogHelp))
+        : UIActionSimple(pParent, UIIconPool::defaultIcon(UIIconPool::UIDefaultIconType_DialogHelp), true)
     {
         retranslateUi();
@@ -722,5 +738,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleWebSite(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/site_16px.png", ":/site_16px.png")
+        : UIActionSimple(pParent, ":/site_16px.png", ":/site_16px.png", true)
     {
         retranslateUi();
@@ -769,5 +785,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleBugTracker(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/site_bugtracker_16px.png", ":/site_bugtracker_16px.png")
+        : UIActionSimple(pParent, ":/site_bugtracker_16px.png", ":/site_bugtracker_16px.png", true)
     {
         retranslateUi();
@@ -816,5 +832,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleForums(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/site_forum_16px.png", ":/site_forum_16px.png")
+        : UIActionSimple(pParent, ":/site_forum_16px.png", ":/site_forum_16px.png", true)
     {
         retranslateUi();
@@ -863,5 +879,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleOracle(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/site_oracle_16px.png", ":/site_oracle_16px.png")
+        : UIActionSimple(pParent, ":/site_oracle_16px.png", ":/site_oracle_16px.png", true)
     {
         retranslateUi();
@@ -910,5 +926,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleResetWarnings(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/reset_warnings_16px.png", ":/reset_warnings_16px.png")
+        : UIActionSimple(pParent, ":/reset_warnings_16px.png", ":/reset_warnings_16px.png", true)
     {
         setMenuRole(QAction::ApplicationSpecificRole);
@@ -959,5 +975,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleNetworkAccessManager(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/download_manager_16px.png", ":/download_manager_16px.png")
+        : UIActionSimple(pParent, ":/download_manager_16px.png", ":/download_manager_16px.png", true)
     {
         setMenuRole(QAction::ApplicationSpecificRole);
@@ -1007,5 +1023,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleCheckForUpdates(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/refresh_16px.png", ":/refresh_disabled_16px.png")
+        : UIActionSimple(pParent, ":/refresh_16px.png", ":/refresh_disabled_16px.png", true)
     {
         setMenuRole(QAction::ApplicationSpecificRole);
@@ -1056,5 +1072,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleAbout(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/about_16px.png", ":/about_16px.png")
+        : UIActionSimple(pParent, ":/about_16px.png", ":/about_16px.png", true)
     {
         setMenuRole(QAction::AboutRole);
@@ -1116,5 +1132,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimplePreferences(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/global_settings_16px.png", ":/global_settings_16px.png")
+        : UIActionSimple(pParent, ":/global_settings_16px.png", ":/global_settings_16px.png", true)
     {
         setMenuRole(QAction::PreferencesRole);
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.h	(revision 73790)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPool.h	(revision 73791)
@@ -164,4 +164,6 @@
     /** Returns action type. */
     UIActionType type() const { return m_enmType; }
+    /** Returns whether this is machine-menu action. */
+    bool machineMenuAction() const { return m_fMachineMenuAction; }
 
     /** Returns menu contained by this action. */
@@ -217,5 +219,5 @@
     /** Constructs action passing @a pParent to the base-class.
       * @param  enmType  Brings the action type. */
-    UIAction(UIActionPool *pParent, UIActionType enmType);
+    UIAction(UIActionPool *pParent, UIActionType enmType, bool fMachineMenuAction = false);
 
     /** Returns current action name in menu. */
@@ -232,4 +234,6 @@
     /** Holds the action type. */
     UIActionType  m_enmType;
+    /** Holds whether this is machine-menu action. */
+    bool          m_fMachineMenuAction;
 
     /** Holds the reference to the action-pool this action belongs to. */
@@ -289,23 +293,31 @@
 protected:
 
-    /** Constructs simple action passing @a pParent to the base-class. */
-    UIActionSimple(UIActionPool *pParent);
     /** Constructs simple action passing @a pParent to the base-class.
-      * @param  strIcon          Brings the normal-icon name.
-      * @param  strIconDisabled  Brings the disabled-icon name. */
+      * @param  fMachineMenuAction  Brings whether this action is a part of machine menu. */
     UIActionSimple(UIActionPool *pParent,
-                   const QString &strIcon, const QString &strIconDisabled);
+                   bool fMachineMenuAction = false);
+    /** Constructs simple action passing @a pParent to the base-class.
+      * @param  strIcon             Brings the normal-icon name.
+      * @param  strIconDisabled     Brings the disabled-icon name.
+      * @param  fMachineMenuAction  Brings whether this action is a part of machine menu. */
+    UIActionSimple(UIActionPool *pParent,
+                   const QString &strIcon, const QString &strIconDisabled,
+                   bool fMachineMenuAction = false);
     /** Constructs simple action passing @a pParent to the base-class.
       * @param  strIconNormal          Brings the normal-icon name.
       * @param  strIconSmall           Brings the small-icon name.
       * @param  strIconNormalDisabled  Brings the normal-disabled-icon name.
-      * @param  strIconSmallDisabled   Brings the small-disabled-icon name. */
+      * @param  strIconSmallDisabled   Brings the small-disabled-icon name.
+      * @param  fMachineMenuAction     Brings whether this action is a part of machine menu. */
     UIActionSimple(UIActionPool *pParent,
                    const QString &strIconNormal, const QString &strIconSmall,
-                   const QString &strIconNormalDisabled, const QString &strIconSmallDisabled);
+                   const QString &strIconNormalDisabled, const QString &strIconSmallDisabled,
+                   bool fMachineMenuAction = false);
     /** Constructs simple action passing @a pParent to the base-class.
-      * @param  icon  Brings the icon. */
+      * @param  icon                Brings the icon.
+      * @param  fMachineMenuAction  Brings whether this action is a part of machine menu. */
     UIActionSimple(UIActionPool *pParent,
-                   const QIcon &icon);
+                   const QIcon &icon,
+                   bool fMachineMenuAction = false);
 };
 
@@ -318,23 +330,31 @@
 protected:
 
-    /** Constructs toggle action passing @a pParent to the base-class. */
-    UIActionToggle(UIActionPool *pParent);
     /** Constructs toggle action passing @a pParent to the base-class.
-      * @param  strIcon          Brings the normal-icon name.
-      * @param  strIconDisabled  Brings the disabled-icon name. */
+      * @param  fMachineMenuAction  Brings whether this action is a part of machine menu. */
     UIActionToggle(UIActionPool *pParent,
-                   const QString &strIcon, const QString &strIconDisabled);
+                   bool fMachineMenuAction = false);
+    /** Constructs toggle action passing @a pParent to the base-class.
+      * @param  strIcon             Brings the normal-icon name.
+      * @param  strIconDisabled     Brings the disabled-icon name.
+      * @param  fMachineMenuAction  Brings whether this action is a part of machine menu. */
+    UIActionToggle(UIActionPool *pParent,
+                   const QString &strIcon, const QString &strIconDisabled,
+                   bool fMachineMenuAction = false);
     /** Constructs toggle action passing @a pParent to the base-class.
       * @param  strIconOn           Brings the on-icon name.
       * @param  strIconOff          Brings the off-icon name.
       * @param  strIconOnDisabled   Brings the on-disabled-icon name.
-      * @param  strIconOffDisabled  Brings the off-disabled-icon name. */
+      * @param  strIconOffDisabled  Brings the off-disabled-icon name.
+      * @param  fMachineMenuAction  Brings whether this action is a part of machine menu. */
     UIActionToggle(UIActionPool *pParent,
                    const QString &strIconOn, const QString &strIconOff,
-                   const QString &strIconOnDisabled, const QString &strIconOffDisabled);
+                   const QString &strIconOnDisabled, const QString &strIconOffDisabled,
+                   bool fMachineMenuAction = false);
     /** Constructs toggle action passing @a pParent to the base-class.
-      * @param  icon  Brings the icon. */
+      * @param  icon                Brings the icon.
+      * @param  fMachineMenuAction  Brings whether this action is a part of machine menu. */
     UIActionToggle(UIActionPool *pParent,
-                   const QIcon &icon);
+                   const QIcon &icon,
+                   bool fMachineMenuAction = false);
 
 private:
Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolRuntime.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolRuntime.cpp	(revision 73790)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/UIActionPoolRuntime.cpp	(revision 73791)
@@ -89,5 +89,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimeShowSettings(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/vm_settings_16px.png", ":/vm_settings_disabled_16px.png")
+        : UIActionSimple(pParent, ":/vm_settings_16px.png", ":/vm_settings_disabled_16px.png", true)
     {}
 
@@ -139,5 +139,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformTakeSnapshot(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/snapshot_take_16px.png", ":/snapshot_take_disabled_16px.png")
+        : UIActionSimple(pParent, ":/snapshot_take_16px.png", ":/snapshot_take_disabled_16px.png", true)
     {}
 
@@ -189,5 +189,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimeShowInformationDialog(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/session_info_16px.png", ":/session_info_disabled_16px.png")
+        : UIActionSimple(pParent, ":/session_info_16px.png", ":/session_info_disabled_16px.png", true)
     {}
 
@@ -241,5 +241,6 @@
         : UIActionToggle(pParent,
                          ":/vm_pause_on_16px.png", ":/vm_pause_16px.png",
-                         ":/vm_pause_on_disabled_16px.png", ":/vm_pause_disabled_16px.png")
+                         ":/vm_pause_on_disabled_16px.png", ":/vm_pause_disabled_16px.png",
+                         true)
     {}
 
@@ -291,5 +292,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformReset(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/vm_reset_16px.png", ":/vm_reset_disabled_16px.png")
+        : UIActionSimple(pParent, ":/vm_reset_16px.png", ":/vm_reset_disabled_16px.png", true)
     {}
 
@@ -341,5 +342,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformDetach(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/vm_create_shortcut_16px.png", ":/vm_create_shortcut_disabled_16px.png")
+        : UIActionSimple(pParent, ":/vm_create_shortcut_16px.png", ":/vm_create_shortcut_disabled_16px.png", true)
     {}
 
@@ -385,5 +386,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformSaveState(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/vm_save_state_16px.png", ":/vm_save_state_disabled_16px.png")
+        : UIActionSimple(pParent, ":/vm_save_state_16px.png", ":/vm_save_state_disabled_16px.png", true)
     {}
 
@@ -429,5 +430,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformShutdown(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/vm_shutdown_16px.png", ":/vm_shutdown_disabled_16px.png")
+        : UIActionSimple(pParent, ":/vm_shutdown_16px.png", ":/vm_shutdown_disabled_16px.png", true)
     {}
 
@@ -483,5 +484,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformPowerOff(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/vm_poweroff_16px.png", ":/vm_poweroff_disabled_16px.png")
+        : UIActionSimple(pParent, ":/vm_poweroff_16px.png", ":/vm_poweroff_disabled_16px.png", true)
     {}
 
@@ -601,5 +602,6 @@
         : UIActionToggle(pParent,
                          ":/fullscreen_on_16px.png", ":/fullscreen_16px.png",
-                         ":/fullscreen_on_disabled_16px.png", ":/fullscreen_disabled_16px.png")
+                         ":/fullscreen_on_disabled_16px.png", ":/fullscreen_disabled_16px.png",
+                         true)
     {}
 
@@ -653,5 +655,6 @@
         : UIActionToggle(pParent,
                          ":/seamless_on_16px.png", ":/seamless_16px.png",
-                         ":/seamless_on_disabled_16px.png", ":/seamless_disabled_16px.png")
+                         ":/seamless_on_disabled_16px.png", ":/seamless_disabled_16px.png",
+                         true)
     {}
 
@@ -705,5 +708,6 @@
         : UIActionToggle(pParent,
                          ":/scale_on_16px.png", ":/scale_16px.png",
-                         ":/scale_on_disabled_16px.png", ":/scale_disabled_16px.png")
+                         ":/scale_on_disabled_16px.png", ":/scale_disabled_16px.png",
+                         true)
     {}
 
@@ -756,5 +760,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformMinimizeWindow(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/minimize_16px.png", ":/minimize_16px.png")
+        : UIActionSimple(pParent, ":/minimize_16px.png", ":/minimize_16px.png", true)
     {}
 
@@ -807,5 +811,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformWindowAdjust(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/adjust_win_size_16px.png", ":/adjust_win_size_disabled_16px.png")
+        : UIActionSimple(pParent, ":/adjust_win_size_16px.png", ":/adjust_win_size_disabled_16px.png", true)
     {}
 
@@ -859,5 +863,6 @@
         : UIActionToggle(pParent,
                          ":/auto_resize_on_on_16px.png", ":/auto_resize_on_16px.png",
-                         ":/auto_resize_on_on_disabled_16px.png", ":/auto_resize_on_disabled_16px.png")
+                         ":/auto_resize_on_on_disabled_16px.png", ":/auto_resize_on_disabled_16px.png",
+                         true)
     {}
 
@@ -903,5 +908,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformTakeScreenshot(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/screenshot_take_16px.png", ":/screenshot_take_disabled_16px.png")
+        : UIActionSimple(pParent, ":/screenshot_take_16px.png", ":/screenshot_take_disabled_16px.png", true)
     {}
 
@@ -990,5 +995,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimeShowVideoCaptureSettings(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/video_capture_settings_16px.png", ":/video_capture_settings_16px.png")
+        : UIActionSimple(pParent, ":/video_capture_settings_16px.png", ":/video_capture_settings_16px.png", true)
     {}
 
@@ -1036,5 +1041,6 @@
         : UIActionToggle(pParent,
                          ":/video_capture_on_16px.png", ":/video_capture_16px.png",
-                         ":/video_capture_on_disabled_16px.png", ":/video_capture_disabled_16px.png")
+                         ":/video_capture_on_disabled_16px.png", ":/video_capture_disabled_16px.png",
+                         true)
     {}
 
@@ -1082,5 +1088,6 @@
         : UIActionToggle(pParent,
                          ":/vrdp_on_16px.png", ":/vrdp_16px.png",
-                         ":/vrdp_on_disabled_16px.png", ":/vrdp_disabled_16px.png")
+                         ":/vrdp_on_disabled_16px.png", ":/vrdp_disabled_16px.png",
+                         true)
     {}
 
@@ -1163,5 +1170,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimeShowMenuBarSettings(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/menubar_settings_16px.png", ":/menubar_settings_disabled_16px.png")
+        : UIActionSimple(pParent, ":/menubar_settings_16px.png", ":/menubar_settings_disabled_16px.png", true)
     {}
 
@@ -1210,5 +1217,6 @@
         : UIActionToggle(pParent,
                          ":/menubar_on_16px.png", ":/menubar_16px.png",
-                         ":/menubar_on_disabled_16px.png", ":/menubar_disabled_16px.png")
+                         ":/menubar_on_disabled_16px.png", ":/menubar_disabled_16px.png",
+                         true)
     {}
 
@@ -1292,5 +1300,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimeShowStatusBarSettings(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/statusbar_settings_16px.png", ":/statusbar_settings_disabled_16px.png")
+        : UIActionSimple(pParent, ":/statusbar_settings_16px.png", ":/statusbar_settings_disabled_16px.png", true)
     {}
 
@@ -1338,5 +1346,6 @@
         : UIActionToggle(pParent,
                          ":/statusbar_on_16px.png", ":/statusbar_16px.png",
-                         ":/statusbar_on_disabled_16px.png", ":/statusbar_disabled_16px.png")
+                         ":/statusbar_on_disabled_16px.png", ":/statusbar_disabled_16px.png",
+                         true)
     {}
 
@@ -1494,5 +1503,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimeShowKeyboardSettings(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/keyboard_settings_16px.png", ":/keyboard_settings_disabled_16px.png")
+        : UIActionSimple(pParent, ":/keyboard_settings_16px.png", ":/keyboard_settings_disabled_16px.png", true)
     {}
 
@@ -1538,5 +1547,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformTypeCAD(UIActionPool *pParent)
-        : UIActionSimple(pParent)
+        : UIActionSimple(pParent, true)
     {}
 
@@ -1589,5 +1598,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformTypeCABS(UIActionPool *pParent)
-        : UIActionSimple(pParent)
+        : UIActionSimple(pParent, true)
     {}
 
@@ -1640,5 +1649,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformTypeCtrlBreak(UIActionPool *pParent)
-        : UIActionSimple(pParent)
+        : UIActionSimple(pParent, true)
     {}
 
@@ -1684,5 +1693,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformTypeInsert(UIActionPool *pParent)
-        : UIActionSimple(pParent)
+        : UIActionSimple(pParent, true)
     {}
 
@@ -1728,5 +1737,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformTypePrintScreen(UIActionPool *pParent)
-        : UIActionSimple(pParent)
+        : UIActionSimple(pParent, true)
     {}
 
@@ -1772,5 +1781,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformTypeAltPrintScreen(UIActionPool *pParent)
-        : UIActionSimple(pParent)
+        : UIActionSimple(pParent, true)
     {}
 
@@ -1855,5 +1864,6 @@
         : UIActionToggle(pParent,
                          ":/mouse_can_seamless_on_16px.png", ":/mouse_can_seamless_16px.png",
-                         ":/mouse_can_seamless_on_disabled_16px.png", ":/mouse_can_seamless_disabled_16px.png")
+                         ":/mouse_can_seamless_on_disabled_16px.png", ":/mouse_can_seamless_disabled_16px.png",
+                         true)
     {}
 
@@ -1976,5 +1986,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimeShowHardDrivesSettings(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/hd_settings_16px.png", ":/hd_settings_disabled_16px.png")
+        : UIActionSimple(pParent, ":/hd_settings_16px.png", ":/hd_settings_disabled_16px.png", true)
     {}
 
@@ -2137,5 +2147,6 @@
         : UIActionToggle(pParent,
                          ":/audio_output_on_16px.png", ":/audio_output_16px.png",
-                         ":/audio_output_on_16px.png", ":/audio_output_16px.png")
+                         ":/audio_output_on_16px.png", ":/audio_output_16px.png",
+                         true)
     {}
 
@@ -2183,5 +2194,6 @@
         : UIActionToggle(pParent,
                          ":/audio_input_on_16px.png", ":/audio_input_16px.png",
-                         ":/audio_input_on_16px.png", ":/audio_input_16px.png")
+                         ":/audio_input_on_16px.png", ":/audio_input_16px.png",
+                         true)
     {}
 
@@ -2264,5 +2276,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimeShowNetworkSettings(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/nw_settings_16px.png", ":/nw_settings_disabled_16px.png")
+        : UIActionSimple(pParent, ":/nw_settings_16px.png", ":/nw_settings_disabled_16px.png", true)
     {}
 
@@ -2347,5 +2359,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimeShowUSBDevicesSettings(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/usb_settings_16px.png", ":/usb_settings_disabled_16px.png")
+        : UIActionSimple(pParent, ":/usb_settings_16px.png", ":/usb_settings_disabled_16px.png", true)
     {}
 
@@ -2541,5 +2553,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimeShowSharedFoldersSettings(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/sf_settings_16px.png", ":/sf_settings_disabled_16px.png")
+        : UIActionSimple(pParent, ":/sf_settings_16px.png", ":/sf_settings_disabled_16px.png", true)
     {}
 
@@ -2585,5 +2597,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimePerformInstallGuestTools(UIActionPool *pParent)
-        : UIActionSimple(pParent, ":/guesttools_16px.png", ":/guesttools_disabled_16px.png")
+        : UIActionSimple(pParent, ":/guesttools_16px.png", ":/guesttools_disabled_16px.png", true)
     {}
 
@@ -2667,5 +2679,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimeShowStatistics(UIActionPool *pParent)
-        : UIActionSimple(pParent)
+        : UIActionSimple(pParent, true)
     {}
 
@@ -2710,5 +2722,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimeShowCommandLine(UIActionPool *pParent)
-        : UIActionSimple(pParent)
+        : UIActionSimple(pParent, true)
     {}
 
@@ -2753,5 +2765,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionToggleRuntimeLogging(UIActionPool *pParent)
-        : UIActionToggle(pParent)
+        : UIActionToggle(pParent, true)
     {}
 
@@ -2796,5 +2808,5 @@
     /** Constructs action passing @a pParent to the base-class. */
     UIActionSimpleRuntimeShowLogs(UIActionPool *pParent)
-        : UIActionSimple(pParent)
+        : UIActionSimple(pParent, true)
     {}
 